// Edge extractor using adjacency data

#version 150

layout(triangles_adjacency) in;
layout(line_strip, max_vertices = 6) out;

in vec2 texCoord[6];
in vec3 exNormal[6];
out vec3 exNormalG;
uniform mat4 projMatrix;

void main()
{
  // Calculate normals of all four triangles
  // Note: All positions are in view coordinates!
  
  
  // We will now test if the center and the adjacent polygon are facing in different
  // directions. For that 
  
  vec3 a = vec3(gl_in[0].gl_Position - gl_in[2].gl_Position);
  vec3 b = vec3(gl_in[0].gl_Position - gl_in[4].gl_Position);
  vec3 nc = -cross(a, b);
  float c = dot(nc, vec3(gl_in[0].gl_Position));
 
  a = vec3(gl_in[0].gl_Position - gl_in[1].gl_Position);
  b = vec3(gl_in[0].gl_Position - gl_in[2].gl_Position);
  vec3 n1 = cross(a, b);
  float c1 = dot(n1, vec3(gl_in[0].gl_Position));
  
  if (c1*c > 0)
  {
      gl_Position = projMatrix * gl_in[0].gl_Position;
      exNormalG = exNormal[0];
      EmitVertex();
      gl_Position = projMatrix * gl_in[2].gl_Position;
      exNormalG = exNormal[2];
      EmitVertex();
  }
  EndPrimitive();
  
  a = vec3(gl_in[2].gl_Position - gl_in[3].gl_Position);
  b = vec3(gl_in[2].gl_Position - gl_in[4].gl_Position);
  vec3 n2 = cross(a, b);
  float c2 = dot(n2, vec3(gl_in[2].gl_Position));

  if (c2*c > 0)
  {
      gl_Position = projMatrix * gl_in[2].gl_Position;
      exNormalG = exNormal[2];
      EmitVertex();
      gl_Position = projMatrix * gl_in[4].gl_Position;
      exNormalG = exNormal[4];
      EmitVertex();
  }
  EndPrimitive();

  a = vec3(gl_in[0].gl_Position - gl_in[4].gl_Position);
  b = vec3(gl_in[0].gl_Position - gl_in[5].gl_Position);
  vec3 n3 = cross(a, b);
  float c3 = dot(n3, vec3(gl_in[0].gl_Position));

  if (c3*c > 0)
  {
      gl_Position = projMatrix * gl_in[0].gl_Position;
      exNormalG = exNormal[0];
      EmitVertex();
      gl_Position = projMatrix * gl_in[4].gl_Position;
      exNormalG = exNormal[4];
      EmitVertex();
  }
  EndPrimitive();  
}
